package bytecode;

import static org.junit.Assert.*;

import java.io.File;
import java.lang.reflect.Method;
import java.net.URL;
import java.net.URLClassLoader;

import org.junit.BeforeClass;
import org.junit.Test;

import de.dhbwstuttgart.core.JavaTXCompiler;

public class Tph2Test {
	
	private static String path;
	private static File fileToTest;
	private static JavaTXCompiler compiler;
	private static ClassLoader loader;
	private static Class<?> classToTest;
	private static String pathToClassFile;
	private static Object instanceOfClass;
	
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		path = System.getProperty("user.dir")+"/src/test/resources/bytecode/javFiles/Tph2.jav";
		fileToTest = new File(path);
		compiler = new JavaTXCompiler(fileToTest);
		pathToClassFile = System.getProperty("user.dir")+"/src/test/resources/testBytecode/generatedBC/";
		compiler.generateBytecode(pathToClassFile);
		loader = new URLClassLoader(new URL[] {new URL("file://"+pathToClassFile)});
		classToTest = loader.loadClass("Tph2");
		instanceOfClass = classToTest.getDeclaredConstructor().newInstance();
	}

	@Test
	public void test1() throws Exception {
		Method m = classToTest.getDeclaredMethod("m", Object.class, Object.class);
		Object result = m.invoke(instanceOfClass, 1,2);
		
		assertEquals(1,result);
	}
	
	@Test
	public void test2() throws Exception {
		Method m = classToTest.getDeclaredMethod("m", Object.class, Object.class);
		Object result = m.invoke(instanceOfClass, "sss",2);
		
		assertEquals("sss",result);
	}
	
	@Test
	public void test3() throws Exception {
		Method m = classToTest.getDeclaredMethod("m2", Object.class, Object.class);
		Object result = m.invoke(instanceOfClass, 1,2);
		
		assertEquals(2,result);
	}
	
	@Test
	public void test4() throws Exception {
		Method m = classToTest.getDeclaredMethod("m2", Object.class, Object.class);
		Object result = m.invoke(instanceOfClass, 1,"xxx");
		
		assertEquals("xxx",result);
	}

}
